
\section{{\em jxta} Module}


\subsection{Overview}

\subsubsection{Module description}
% TODO

\subsubsection{Dependencies}
Here are the dependancies of the \textbf{jxta} module :
\begin{description}
	\item[BaseI module] Because it uses lots of interfaces defined there.
	\item[communication module] Because the module \textbf{jxta} is a \textbf{communication} frontend.
	\item[JXTA-jxse] It is the framework used for accessing peers and sending/receiving messages.
\end{description}


\subsection{JXTA Framework}
% TODO


\subsection{Classes description and Diagrams}

\subsubsection{Main package : {\bf fr.lri.iasi.somewhere.jxta}}
Here is a list of the classes of this package, and there description :
\begin{description}
	\item[AdvertisementsPrettyPrinter] TODO
	\item[JXTALocalPeer] TODO
	\item[JXTALocalPeerPrettyPrinter] TODO
	\item[JXTAManager] TODO
	\item[JXTAMessage] TODO
	\item[JXTAPeer] TODO
	\item[MessageSender] TODO
	\item[PeerGroup] TODO
	\item[PeerGroupPrettyPrinter] TODO
	\item[PipeListener] TODO
\end{description}
% TODO
\textbf{TODO : Add UML Diagrams}

\subsubsection{Configuration Package : {\bf fr.lri.iasi.somewhere.jxta.configuration}}
Here is a list of the classes of this package, and there description :
\begin{description}
	\item[Configuration] TODO
	\item[JXTAXMLConfiguration] TODO
\end{description}
%TODO
\textbf{TODO : Add UML Diagrams}

\subsubsection{Commands Package : {\bf fr.lri.iasi.somewhere.jxta.commands}}
Here is a list of the classes of this package, and there description :
\begin{description}
	\item[JXTAAdvertisementsListCommand] TODO
	\item[JXTAPeerGroupStatusCommand] TODO
	\item[JXTAPeerStatusCommand] TODO
\end{description}
%TODO
\textbf{TODO : Add UML Diagrams}




\subsection{Configuration System}

\subsubsection{Description}
%TODO

\subsubsection{XSD XML Schema}
Here is the XSD file used for configuring this module :
\begin{lstlisting}[language=xml]
<?xml version="1.0" encoding="UTF-8"?>
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema">


	<xsd:element name="jxtaConfig">
		<xsd:complexType>

			<xsd:all>
				<xsd:element name="localPeer" type="localPeer" />
				<xsd:element name="seeds" type="seeds" />
				<xsd:element name="network" type="network" />
				<xsd:element name="service" type="service" />
				<xsd:element name="message" type="message" />
			</xsd:all>

		</xsd:complexType>
	</xsd:element>


	<xsd:complexType name="localPeer">
		<xsd:all>
			<xsd:element name="peerName" type="xsd:string" />
			<xsd:element name="peerGroupName" type="xsd:string" />
			<xsd:element name="peerType" type="xsd:string" /> <!--TODO : restriction -->
			<xsd:element name="peerID" type="xsd:integer" />
			<xsd:element name="autoRdvEnabled" type="xsd:boolean" />
			<xsd:element name="cacheFolder" type="xsd:string" />
			<xsd:element name="cacheReUse" type="xsd:string" />
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="seeds">
		<xsd:all>
			<xsd:element name="rdvPeers" type="rdvPeers" />
			<xsd:element name="relayPeers" type="relayPeers" />
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="network">
		<xsd:all>
			<xsd:element name="port" type="xsd:integer" />
			<xsd:element name="Enabled" type="xsd:boolean" />
			<xsd:element name="IncomingEnabled" type="xsd:boolean" />
			<xsd:element name="OutgoingEnabled" type="xsd:boolean" />
			<xsd:element name="cachedOutputPipe" type="xsd:boolean" />
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="service">
		<xsd:all>
			<xsd:element name="version" type="xsd:integer" />
			<xsd:element name="creator" type="xsd:string" />
			<xsd:element name="URL" type="xsd:anyURI" />
			<xsd:element name="inpipePipeID" type="xsd:integer" />
			<xsd:element name="moduleClassID" type="xsd:integer" />
			<xsd:element name="advExpirationTime" type="xsd:integer" />
			<xsd:element name="advLifeTime" type="xsd:integer" />
		</xsd:all>
	</xsd:complexType>

	<xsd:complexType name="message">
		<xsd:all>
			<xsd:element name="pipeResolveTimeout" type="xsd:integer" />
			<xsd:element name="numberOfRetriesForDiscovery" type="xsd:integer" />
			<xsd:element name="gapBetweenTwoDiscoveryRequests" type="xsd:integer" />
			<xsd:element name="timeoutForAMessage" type="xsd:integer" />
		</xsd:all>
	</xsd:complexType>


	<xsd:complexType name="rdvPeers">
		<xsd:sequence>
			<xsd:element name="peer" type="peer" minOccurs="0" maxOccurs="unbounded" />
		</xsd:sequence>
	</xsd:complexType>

	<xsd:complexType name="relayPeers">
		<xsd:sequence>
			<xsd:element name="peer" type="peer" minOccurs="0" maxOccurs="unbounded" />
		</xsd:sequence>
	</xsd:complexType>


	<xsd:complexType name="peer">
		<xsd:simpleContent>
			<xsd:extension base="xsd:string">
			</xsd:extension>
		</xsd:simpleContent>
	</xsd:complexType>


</xsd:schema>   

\end{lstlisting}



